/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: StringHLine.h,v 1.2 2001/11/01 07:30:36 yoshi Exp $ */ 
#ifndef StringHLine_h
#define StringHLine_h

#include <string.h>

class StringHLine
{
private:
	char	*m_buf;		
	int	m_length;	 
	int	m_charStart;
	bool	m_release;	// obt@̉
	int	m_index;		// CCfbNX

private:
	int	length() { return m_length; }
public:
	StringHLine(char *buf, int charStart, int index_, bool release = true) : m_charStart(charStart)
	{
		m_buf = buf;
		m_length = strlen(m_buf);
		m_index = index_;
		m_release = release? true: false;
	}

	virtual ~StringHLine() { if (m_release && m_buf) { delete [] m_buf; } }

	// n܂ʒu
	int	charStart() { return m_charStart; }

	// C̕
	int	width() { return m_length;}

	char	element(int i) { return (0 <= i && i < length())? m_buf[i]: ' '; }
	char *	buffer() { return m_buf; }
	int	totalLineIndex() { return m_index; }
};

#endif  // StringHLine_h
