/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PHTexBlockContext.h,v 1.5 2004/01/19 12:20:24 yoshi Exp $ */ 
#ifndef PHTexBlockContext_h
#define PHTexBlockContext_h

#include "PHBlockList.h"

class PHTexBlockContext
{
private:
	typedef PHBlock::Node BlockNode;
	typedef PHBlock::List BlockList;
	
public:
	// ̓XgvfȂ̂BlockNodeƂĂ邪A
	// ̃NX̃[Uɂ͒PȂBlockƂđ
	// ł悢B
	typedef PHBlock::Node Block;
	typedef PHBlock::IgnoreNode IgnoreBlock;
	typedef PHBlock::ConvertNode ConvertBlock;
	typedef PHBlock::DefaultNode DefaultBlock;

private:
	BlockList	m_blocks;
private:
	void	free_();
public:
	void	push(Block *b) { m_blocks.push(b); }
	bool convert(const char *name) {
		return m_blocks.convert(name);
	}
};

#endif // PHTexBlockContext_h
 
