/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: libtest.c,v 1.7 2004/02/23 07:55:06 yoshi Exp $ */

/*

  PaperHouse : TeXϊCuTv

       gcc libtest.c -L. -lphtex -lm -lstdc++

*/
#include "PHTex.h"
#include <stdio.h>

/*
  t@C̓eTeX`ɕϊ
 */
static char *toTex(const char *fname)
{
	unsigned	options = 0;
	char *          tex;
	char		buf[1024];
	FILE *		fp;
	fp = fopen(fname, "r");

	if (!fp) { printf("cannot open file %s\n", fname); exit(1); }

	while (fgets(buf, sizeof(buf), fp)) {
		/*
		   sPʂœ́Bœ͂̃Rs[ێĂB
		 */
		PHTexPushLine(buf);
	}
	fclose(fp);


	/*
	  flag ̒lɂPROC̏̎sؑւs}N
	  0ȊO̒lw肷΁ALqLɂȂB
	*/
#define VALIDATE(PROC, FLAG) if (FLAG) { PROC; }


	/* ԍt */
	VALIDATE((options |= PHTEX_ENUMERATE_EQUATION), 0);

	/* ^OENLqo͂ */
	VALIDATE((options |= PHTEX_OUTPUT_TAG_DESCRIPTION), 0);

	/* [[]] gpgݍ݋Lq𖳎 */
	VALIDATE((options |= PHTEX_ELIMINATE_EMBEDDED_DESCRIPTION), 0);

	/* ͍sƏo͍s킹 */
	VALIDATE((options |= PHTEX_SAME_LINE_NUMBER), 1);

	/* ͂\begin{...}  \end{..} ubNo͂Ȃ  */
	VALIDATE((options |= PHTEX_NO_EQUATION_BLOCK), 1);

	/*
	  PHTexPushLineœ͂LqTeX`ɕϊ 

	  PHTexToTex ̌ĂяoI_ŁAPHTexPushLineœ
	  Lq͔jĂ
	*/
	tex = PHTexToTex(options);
	return tex;
}

int main(int argc, char **argv)
{
	int ret = 0;
	int i;
	int num;
	char *fname;
	char *str;

	if (argc == 1) { printf("%s file1 file2 ...\n", argv[0]); return 1; }

	/*
	  CȕB
	  
	  ̃Cu֐ĂяoOɕKĂяo
	*/
	PHTexInit();

	for (i=1; i<argc; i++) { 
		char *fname = argv[i];
		if (str = toTex(fname)) {
			printf(str);
		} else {
			/* sG[bZ[Wo͂ďI*/
			printf("%s\n", PHTexGetLastError());
			ret = 1;
			break;
		}
	}

	/* ̃CuKvȂȂ_ŌĂяo */
	PHTexFree();
	
	return ret;
}
