/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: matex.h,v 1.2 2004/05/06 05:11:16 yoshi Exp $ */ 
#ifndef matex_h
#define matex_h

/* #############################################
  
        TeX`ϊIvV

  ############################################## */


/* IvVwȂ*/
#define MATEX_NOOPTION				0x00
/* ԍt */
#define MATEX_ENUMERATE_EQUATION		0x01
/* ^OENLqo͂ */
#define MATEX_OUTPUT_TAG_DESCRIPTION		0x02
/* [[]] gpgݍ݋Lq𖳎 */
#define MATEX_ELIMINATE_EMBEDDED_DESCRIPTION	0x04
/* ͍sƏo͍s킹 */
#define MATEX_SAME_LINE_NUMBER			0x10
/* ͂\begin{...}  \end{..} ubNo͂Ȃ  */
#define MATEX_NO_EQUATION_BLOCK                 0x20
/* ͍sƏo͍s킹Ƃ̉sTeX̃RgƂďo */
#define PHTEX_NEWLINE_AS_TEX_COMMENT		0x40

/* IvV̐ݒȂ */
#define MATEX_OPTIONS_NOT_SET			0xffff


#ifdef __cplusplus
extern "C" {
#endif
	/*
	  Lq : int MatexInit()
	  @\ : 
	  Ԃl : Ăяo̐
	        0 -> I
		1 -> ُI
	*/
	int	MatexInit();
	/*
	  Lq : void MatexFree()
	  @\ : ㏈
	*/
	void	MatexFree();

	/*
	  Lq : int MatexPushLine(const char *)

	  @\ : LqǉB

	   :
	    1)  const char * [in]
	    LqsBŌɉsĂ悢B

	  Ԃl : Ăяo̐
	        0 -> I
		1 -> ُI
	*/
	int	MatexPushLine(const char *);

	/*
	  Lq : char *	MatexToTex(unsigned options)

	  @\ : ǉLqs߂āATeX`ɕϊB̊֐
	         ̌Ăяoɂ́A͂Lq̓NAĂB

	   :
	    1) unsigned options [in]
  	    o̓IvVB̃IvVgݍ킹邱Ƃ\

	  Ԃl : TeXLqBĂяosꍇNULL ԂB
	*/
	char *	MatexToTex(unsigned options);

	/*
	  Lq : char *	MatexGetLastError()
	  
	  @\ : ŌɋNG[Lq𓾂

	  Ԃl : G[
	*/
	char *	MatexGetLastError();

	/*
	  Lq : const char * MatexGetVersion()

	  @\ : o[W𓾂B
	 */
	const char *  MatexGetVersion();
#ifdef __cplusplus
}
#endif

/*
  Âo[Wƌ݊ۂ߂̃}N

  PaperHouse MatEx ɖ̕ύXƂjIo܂ɂB
 */

#define PHTEX_NOOPTION				MATEX_NOOPTION
#define PHTEX_ENUMERATE_EQUATION		MATEX_ENUMERATE_EQUATION
#define PHTEX_OUTPUT_TAG_DESCRIPTION		MATEX_OUTPUT_TAG_DESCRIPTION
#define PHTEX_ELIMINATE_EMBEDDED_DESCRIPTION	MATEX_ENUMERATE_EQUATION
#define PHTEX_SAME_LINE_NUMBER			MATEX_SAME_LINE_NUMBER
#define PHTEX_NO_EQUATION_BLOCK                 MATEX_NO_EQUATION_BLOCK
#define PHTEX_OPTIONS_NOT_SET			MATEX_OPTIONS_NOT_SET

#define	PHTexInit	MatexInit
#define PHTexFree	MatexFree
#define	PHTexPushLine	MatexPushLine
#define PHTexToTex	MatexToTex
#define PHTexGetLastError MatexGetLastError
#define PHTexGetVersion MatexGetVersion

#endif /* matex_h */
