/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: VarString.h,v 1.1 2001/10/24 05:15:38 yoshi Exp $ */ 
#ifndef VarString_h
#define VarString_h

class VarString
{
private:
	enum { RESIZE_UNIT = 20,};
private:
	char *	m_buf;
	int	m_size;
	int	m_index;

	int	m_unit;
private:
	void	resize();

	bool	overflow(int addsize);
		
public:
	VarString();
	virtual ~VarString();

	int	size() { return m_index; }

	char *	push(char *);
	char *	push(char );
	char *	c_str() { return m_buf; }

	VarString &operator+=(char c) { push(c); return *this; }
	VarString &operator+=(char *str) { push(str); return *this; }
};

#endif  // VarString_h
