#include "stdafx.h"
#include "ColorSelectProc.h"
#include <afxdlgs.h>

bool ColorSelectProc::exec()
{
	if (m_color == COLOR_NOT_SET) {
		CColorDialog dlg;
		int ret = dlg.DoModal();
		if (ret != IDOK) { return false; }
		m_color = dlg.GetColor();
	}

	const BYTE r = GetRValue(m_color);
	const BYTE g = GetGValue(m_color);
	const BYTE b = GetBValue(m_color);

	char buf[128];
	sprintf(buf, "%02x%02x%02x", r, g, b);
	m_hexEdit.SetWindowText(buf);

	return true;
}

