/* $Id: ColorSelectProc.h,v 1.1 2003/10/03 04:51:22 yoshi Exp $ */ 
#ifndef ColorSelectProc_h
#define ColorSelectProc_h

class CEdit;

class ColorSelectProc
{
private:
	enum { COLOR_NOT_SET = 0xffffffff, };
private:
	CWnd & m_hexEdit;
	COLORREF	m_color;
public:
	ColorSelectProc(CWnd &hexEdit, COLORREF c)
		: m_hexEdit(hexEdit), m_color(c) {;}

	COLORREF	color() const { return m_color; }
	bool	exec();
	bool	operator()() { return exec(); }
};

#endif // ColorSelectProc_h
 
