// olorSelectDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PHConfig.h"
#include "olorSelectDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ColorSelectDialog _CAO


ColorSelectDialog::ColorSelectDialog(CWnd* pParent /*=NULL*/)
	: CDialog(ColorSelectDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(ColorSelectDialog)
	//}}AFX_DATA_INIT
	m_normalColor = RGB(0, 0, 0);
}


void ColorSelectDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ColorSelectDialog)
	DDX_Control(pDX, IDC_EDIT_HILIGHT_HEX, m_hilightEdit);
	DDX_Control(pDX, IDC_EDIT_LINK_HEX, m_linkEdit);
	DDX_Control(pDX, IDC_EDIT_NORMAL_HEX, m_normalEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ColorSelectDialog, CDialog)
	//{{AFX_MSG_MAP(ColorSelectDialog)
	ON_BN_CLICKED(IDC_BUTTON_NORMAL, OnButtonNormal)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_BUTTON_HILIGHT, OnButtonHilight)
	ON_BN_CLICKED(IDC_BUTTON_LINK, OnButtonLink)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ColorSelectDialog bZ[W nh

#include "ColorSelectProc.h"


HBRUSH ColorSelectDialog::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	const UINT id = pWnd->GetDlgCtrlID();
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	switch(nCtlColor) {
	case CTLCOLOR_EDIT:
		if (id == IDC_EDIT_NORMAL_HEX) {
			pDC->SetTextColor(m_normalColor);
		} else if (id == IDC_EDIT_HILIGHT_HEX) {
			pDC->SetTextColor(m_hilightColor);
		} else if (id == IDC_EDIT_LINK_HEX) {
			pDC->SetTextColor(m_linkColor);
		}
		break;
	}
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}

void ColorSelectDialog::setHilightColor(COLORREF c)
{
	ColorSelectProc proc(m_hilightEdit, c);
	if (proc()) {
		m_hilightColor = proc.color();
	}
}
void ColorSelectDialog::setNormalColor(COLORREF c)
{
	ColorSelectProc proc(m_normalEdit, c);
	if (proc()) {
		m_normalColor = proc.color();
	}
}

void ColorSelectDialog::setLinkColor(COLORREF c)
{
	ColorSelectProc proc(m_linkEdit, c);
	if (proc()) {
		m_linkColor = proc.color();
	}
}

void ColorSelectDialog::OnButtonNormal() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	setNormalColor();
}


void ColorSelectDialog::OnButtonHilight() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	setHilightColor();
}

void ColorSelectDialog::OnButtonLink() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	setLinkColor();
}
