/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationDCDrawer.h,v 1.7 2003/10/02 03:59:01 yoshi Exp $ */ 
#ifndef EquationDCDrawer_h
#define EquationDCDrawer_h

#include <windows.h>
#include "EquationDrawer.h"

class EquationDCDrawer : public EquationDrawer
{
protected:
	class Margin
	{
	public:
		int	x;
		int	y;
		void	set(int x_, int y_) { x = x_; y = y_; }
		Margin() : x(0), y(0) {;}
	};

protected:
	Margin	m_margin;
	void	setMargin(int x, int y) { m_margin.set(x, y); }

protected:

	int	marginX() { return m_margin.x; }
	int	marginY() { return m_margin.y; }

	void	addMargin(int &width, int &height, bool margin);
	virtual bool	margin() { return false; }

private:
	virtual void centerWidth(Equation *, DrawContext *, Length &l);
};
 
#endif  // EquationDCDrawer_h
