/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationSizeManager.h,v 1.4 2002/01/28 05:16:38 yoshi Exp $ */ 
#ifndef EquationSizeManager_h
#define EquationSizeManager_h

#include "DrawLevel.h"

class EquationSizeManager
{
public:
	class Size
	{
	public:
		int	width;
		int	height;
		void	set(int w, int h) { width = w; height = h; }
	};

private:
	Size	m_sizes[DRAWLEVEL_NUM];

private:
	void	init(int size);
#ifdef _DEBUG
	void	checkRange(DrawLevel);
#else
	void	checkRange(DrawLevel) {;}
#endif

public:
	EquationSizeManager() { init(3); }
	EquationSizeManager(int size) { init(size); }

	Size &size(DrawLevel l) { checkRange(l); return m_sizes[l]; }
	Size &bracketSize(DrawLevel);
};
 
#endif  // EquationSizeManager_h
