#include "stdafx.h"
#include "FontListProvider.h"

static int CALLBACK enumFontProc(ENUMLOGFONT *elf, NEWTEXTMETRIC *tm, int type, LPARAM lParam)
{
	HWND hWnd = (HWND) lParam;
	if ((type & TRUETYPE_FONTTYPE) &&  IsWindow(hWnd)) {
		SendMessage(hWnd, LB_ADDSTRING, 0, (LPARAM)elf->elfLogFont.lfFaceName);
	}
	return TRUE;
}

FontListProvider::FontListProvider(CWnd &parent, CListBox &container)
	: m_parent(parent), m_container(container)
{

}

void FontListProvider::provide()
{
	EnumFontFamilies(m_parent.GetDC()->m_hDC, NULL,
			 (FONTENUMPROC)enumFontProc, (LPARAM)m_container.m_hWnd);
}



