// PHConfigDlg.h : wb_[ t@C
//
//{{AFX_INCLUDES()
#include "phmath2d.h"
//}}AFX_INCLUDES

#if !defined(AFX_PHCONFIGDLG_H__CE811925_D8E3_4A62_8878_9DA37BA4D18B__INCLUDED_)
#define AFX_PHCONFIGDLG_H__CE811925_D8E3_4A62_8878_9DA37BA4D18B__INCLUDED_

#include "olorSelectDialog.h"	// ClassView ɂĒǉ܂B
#include "FontSelectDialog.h"	// ClassView ɂĒǉ܂B
#include "PHInfoDlg.h"

#pragma warning(disable:4786)

#include <string>
#include <vector>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



/////////////////////////////////////////////////////////////////////////////
// CPHConfigDlg _CAO

class CPHConfigDlg : public CDialog
{
// \z
public:
	CPHConfigDlg(CWnd* pParent = NULL);	// W̃RXgN^


// _CAO f[^
	//{{AFX_DATA(CPHConfigDlg)
	enum { IDD = IDD_PHCONFIG_DIALOG };
	CComboBox	m_samples;
	CTabCtrl	m_tab;
	CPHMath2D	m_eq;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CPHConfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CPHConfigDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangingTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonRedraw();
	afx_msg void OnButtonDefault();
	afx_msg void OnSelchangeComboSampleList();
	afx_msg void OnEditupdateComboSampleList();
	afx_msg void OnEditchangeComboSampleList();
	afx_msg void OnButtonSetDefault();
	afx_msg void OnButtonSelectFile();
	afx_msg void OnButtonSave();
	afx_msg void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	ColorSelectDialog m_colorTab;
	FontSelectDialog m_fontTab;
	CPHInfoDlg	m_infoTab;

	CString			m_inifile;
	CString			m_tmpfile;
	CString			m_defaultfile;
	std::vector<std::string> m_sampleFiles;
private:
	bool	writeConfig(const char *fname);
	void	initTab();
	bool	loadConfig();
	void	showSampleList();
	void	selectSample(int n = -1);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PHCONFIGDLG_H__CE811925_D8E3_4A62_8878_9DA37BA4D18B__INCLUDED_)
