#if !defined(AFX_OLORSELECTDIALOG_H__C4D93857_D13F_43B7_A02F_7987740EC44D__INCLUDED_)
#define AFX_OLORSELECTDIALOG_H__C4D93857_D13F_43B7_A02F_7987740EC44D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// olorSelectDialog.h : wb_[ t@C
//

/////////////////////////////////////////////////////////////////////////////
// ColorSelectDialog _CAO

class ColorSelectDialog : public CDialog
{
// RXgNV
public:
	ColorSelectDialog(CWnd* pParent = NULL);   // W̃RXgN^
private:
	enum { COLOR_NOT_SET = 0xffffffff, };

private:
	COLORREF m_hilightColor;
	COLORREF m_normalColor;
	COLORREF m_linkColor;

public:
	COLORREF hilightColor() const { return m_hilightColor; }
	COLORREF normalColor() const { return m_normalColor; }
	COLORREF linkColor() const { return m_linkColor; }

	void	setHilightColor(COLORREF c = COLOR_NOT_SET);
	void	setNormalColor(COLORREF c = COLOR_NOT_SET);
	void	setLinkColor(COLORREF c = COLOR_NOT_SET);

public:
// _CAO f[^
	//{{AFX_DATA(ColorSelectDialog)
	enum { IDD = IDD_COLOR_SELECT_DIALOG };
	CEdit	m_hilightEdit;
	CEdit	m_linkEdit;
	CEdit	m_normalEdit;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(ColorSelectDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(ColorSelectDialog)
	afx_msg void OnButtonNormal();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnButtonHilight();
	afx_msg void OnButtonLink();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_OLORSELECTDIALOG_H__C4D93857_D13F_43B7_A02F_7987740EC44D__INCLUDED_)
