// PHMath2DCtl.cpp : CPHMath2DCtrl ActiveX Rg[ NX̃Cve[V

#include "stdafx.h"
#include "PHMath2D.h"
#include "PHMath2DCtl.h"
#include "PHMath2DPpg.h"
#include "Version.h"

#include "ViewBuffer.h"
#include "Math2DContextCreatorSetup.h"
#include "PHControlProperty.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CPHMath2DCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// bZ[W }bv

BEGIN_MESSAGE_MAP(CPHMath2DCtrl, COleControl)
	//{{AFX_MSG_MAP(CPHMath2DCtrl)
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_MESSAGE(WM_FILENAME_UPDATE, CPHMath2DCtrl::OnFilenameUpdate)
	ON_MESSAGE(WM_REDRAW, CPHMath2DCtrl::OnRedraw)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// fBXpb` }bv

BEGIN_DISPATCH_MAP(CPHMath2DCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CPHMath2DCtrl)
	DISP_PROPERTY_EX(CPHMath2DCtrl, "filename", GetFilename, SetFilename, VT_BSTR)
	DISP_PROPERTY_EX(CPHMath2DCtrl, "hilightColor", GetHilightColor, SetHilightColor, VT_I4)
	DISP_PROPERTY_EX(CPHMath2DCtrl, "fontsize", GetFontsize, SetFontsize, VT_I2)
	DISP_PROPERTY_EX(CPHMath2DCtrl, "startNumber", GetStartNumber, SetStartNumber, VT_I4)
	DISP_PROPERTY_EX(CPHMath2DCtrl, "enumeration", GetEnumeration, SetEnumeration, VT_BOOL)
	DISP_FUNCTION(CPHMath2DCtrl, "hilight", hilight, VT_EMPTY, VTS_I2)
	DISP_FUNCTION(CPHMath2DCtrl, "hilightOff", hilightOff, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CPHMath2DCtrl, "hilightAllChar", hilightAllChar, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CPHMath2DCtrl, "getVersion", getVersion, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CPHMath2DCtrl, "redraw", redraw, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CPHMath2DCtrl, "loadConf", loadConf, VT_I4, VTS_BSTR)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CPHMath2DCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Cxg }bv

BEGIN_EVENT_MAP(CPHMath2DCtrl, COleControl)
	//{{AFX_EVENT_MAP(CPHMath2DCtrl)
	EVENT_CUSTOM("LinkTo", FireLinkTo, VTS_PBSTR)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// vpeB y[W

// TODO: vpeB y[WǉāABEGIN s̍ŌɂJEg𑝂₵ĂB
BEGIN_PROPPAGEIDS(CPHMath2DCtrl, 1)
	PROPPAGEID(CPHMath2DPropPage::guid)
END_PROPPAGEIDS(CPHMath2DCtrl)


/////////////////////////////////////////////////////////////////////////////
// NX t@Ng guid ܂

IMPLEMENT_OLECREATE_EX(CPHMath2DCtrl, "PHMATH2D.PHMath2DCtrl.1",
	0x3777f616, 0x8dbe, 0x4836, 0xb4, 0x78, 0xe3, 0x8f, 0xd8, 0x6a, 0xe0, 0x98)


/////////////////////////////////////////////////////////////////////////////
// ^Cv Cu ID ƃo[W

IMPLEMENT_OLETYPELIB(CPHMath2DCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// C^[tFCX ID

const IID BASED_CODE IID_DPHMath2D =
		{ 0x2611f24c, 0x8159, 0x436e, { 0x8c, 0x29, 0xa0, 0xb, 0x8d, 0xdc, 0x9f, 0xc4 } };
const IID BASED_CODE IID_DPHMath2DEvents =
		{ 0x4847b7bb, 0xccff, 0x4817, { 0xa6, 0xe0, 0xcc, 0xaa, 0xce, 0xa1, 0xc2, 0xe2 } };


/////////////////////////////////////////////////////////////////////////////
// Rg[̌^̐

static const DWORD BASED_CODE _dwPHMath2DOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CPHMath2DCtrl, IDS_PHMATH2D, _dwPHMath2DOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl::CPHMath2DCtrlFactory::UpdateRegistry -
// CPHMath2DCtrl ̃VXe WXg̃Ggǉ܂͍폜܂ 

BOOL CPHMath2DCtrl::CPHMath2DCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Rg[Ap[gg f̃Xbh̋Kɏ]Ă邱Ƃ
	// mFĂBڍׂɂĂ MFC ̃eNjJ m[g 64 QƂĂB
	// Ap[gg f̃Xbh̋Kɏ]ȂRg[̏ꍇ́A6 Ԗ
	// ̃p[^ȉ̂悤ɕύXĂB
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_PHMATH2D,
			IDB_PHMATH2D,
			afxRegApartmentThreading,
			_dwPHMath2DOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl::CPHMath2DCtrl - RXgN^

CPHMath2DCtrl::CPHMath2DCtrl()
{
	InitializeIIDs(&IID_DPHMath2D, &IID_DPHMath2DEvents);

	// TODO: ̈ʒuɃRg[̃CX^X f[^̏ǉĂ
	m_drawer = 0;
	m_bgBuffer = 0;
	m_xoffset = 0;
	m_yoffset = 0;
	m_eqSize.cx = m_eqSize.cy = 0;

	m_creator = new Math2DContextCreator(m_fontsize, m_startNumber, m_enum);
	loadDefaultConfig();
	
	const int LENGTH = 128;
	m_strLinkToBuf.GetBufferSetLength(LENGTH);
	m_bstrLinkToBuf = m_strLinkToBuf.AllocSysString();
}

bool CPHMath2DCtrl::loadConfig(const char *fname) 
{
	Math2DContextCreatorSetup setup(*m_creator);
	setup(fname);
	return true;
}

bool CPHMath2DCtrl::loadDefaultConfig()
{
	const char *inifile = PHControlProperty::inifile();
	if (!inifile) { return false; }
	return loadConfig(inifile);
}
		

/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl::~CPHMath2DCtrl - fXgN^

#define FREE(P) if(P) { delete P; P = 0; }

CPHMath2DCtrl::~CPHMath2DCtrl()
{
	// TODO: ̈ʒuɃRg[̃CX^X f[^̌㏈p̃R[hǉĂ
	FREE(m_drawer);
	FREE(m_bgBuffer);
	FREE(m_creator);
//	if (m_drawer) { delete m_drawer; m_drawer = 0; }
//	if (m_bgBuffer) { delete m_bgBuffer; m_bgBuffer = 0; }
//	if (m_creator) { delete m_creator; m_creator = 0; }
}

// 
void CPHMath2DCtrl::init(HDC hDC)
{
	initDrawer(hDC); 
	SetTimer(HILIGHT_TIMER_ID, HILIGHT_TIMER_ELAPSE, 0);
}

/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl::OnDraw - `֐

void CPHMath2DCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: ȉ̃R[h`p̃R[hɒuĂ

	HDC hDC = pdc->m_hDC;
	if (!m_drawer && m_filename.GetLength() > 0) {
		init(hDC);
		draw();
	}

	if (m_drawer) {
		ViewBuffer *buffer = m_drawer->getBuffer();
		if (m_bgBuffer) { 
			::BitBlt(hDC, 0, 0, m_bgBuffer->width(), m_bgBuffer->height(),
				 m_bgBuffer->getDC(), 0, 0, SRCCOPY);
		}

		if (buffer) {
			m_xoffset= (rcBounds.Width() - buffer->width())/2;
			::BitBlt(hDC, m_xoffset, m_yoffset,
				 buffer->width(), buffer->height(),
				 buffer->getDC(), 0, 0, SRCCOPY);
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl::DoPropExchange - ĩT|[g

void CPHMath2DCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: p\eJX^ vpeBp PX_ ֐̌ĂяoǉĂ
	PX_Bool(pPX, _T("auto"), m_auto, FALSE);
	PX_String(pPX, _T("filename"), m_filename, "");
	PX_Long(pPX, _T("hilightcolor"), m_hilightColor, RGB(255, 0, 0));
	PX_Long(pPX, _T("fontsize"), m_fontsize, 3);
	PX_Bool(pPX, _T("enumeration"), m_enum, FALSE);
	PX_Long(pPX, _T("startnumber"), m_startNumber, -1);
}


/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl::OnResetState - Rg[̃vpeBlZbg

void CPHMath2DCtrl::OnResetState()
{
	COleControl::OnResetState();  // DoPropExchange ĂяoăftHglɃZbg

	// ̈ʒuɃRg[̏ԂZbg鏈ǉĂ
}


/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl::AboutBox - "o[W" ̃_CAO {bNX\

void CPHMath2DCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_PHMATH2D);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl bZ[W nh

#define MAX(a, b) ( ((a) > (b))? (a): (b) )

void	CPHMath2DCtrl::resize(Length &wl, Length &hl)
{
	const int width = wl.value();
	const int height = hl.value();

	// ێ
	m_eqSize.cx = width;
	m_eqSize.cy = height;
	m_center.cx = wl.start_center();
	m_center.cy = hl.start_center();

	HDC hDC = GetDC()->m_hDC;

	// obt@TCY̕ύX
	if (m_drawer) { m_drawer->resizeBuffer(hDC, width, height); }

	// Rg[TCY̕ύX
	int w, h;
	GetControlSize(&w, &h);
	if (m_auto) {
		h = height;
		w = width;
	} else {
		if (h < height) { h = height; }
		if (w < width) { w = width; }
	}
	SetControlSize(w, h);

	// wiobt@TCY̕ύX
	if (m_bgBuffer) { delete m_bgBuffer; m_bgBuffer = 0;}
	m_bgBuffer = new ViewBuffer(hDC, w, h);
}

void	CPHMath2DCtrl::updated()
{
	InvalidateRect(NULL);
}

void	CPHMath2DCtrl::draw()
{
	if (m_filename.GetLength() > 0) {
		draw(m_filename);
	}
}


void	CPHMath2DCtrl::draw(const char *filename)
{
	if (m_drawer) {
		m_drawer->clear();
		if (!m_drawer->draw(filename)) {
			delete m_drawer; m_drawer = 0;
			m_filename = "";
		}
	}
}

#define IN_RANGE(v, l, u) ((l < v) && (v < u))

void CPHMath2DCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	m_cursor = point;

	if (IN_RANGE(point.x, m_xoffset, m_xoffset + m_eqSize.cx) &&
	    IN_RANGE(point.y, m_yoffset, m_yoffset + m_eqSize.cy)) {
		inEquationRect(true);
	}
	
	COleControl::OnMouseMove(nFlags, point);
}

void CPHMath2DCtrl::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if (m_drawer && inEquationRect()) {
		char *tags = m_drawer->inLinkRect(m_cursor.x - m_xoffset, m_cursor.y);
		fireLinkTo(tags);
	}
	inEquationRect(false);
	COleControl::OnTimer(nIDEvent);
}

LRESULT CPHMath2DCtrl::OnFilenameUpdate(WPARAM, LPARAM)
{
	InvalidateRect(NULL);
	return MAKELRESULT(0, 0);
}

LRESULT CPHMath2DCtrl::OnRedraw(WPARAM, LPARAM)
{
	if (m_drawer) {
		m_drawer->clear();
		draw();	
	}
	return MAKELRESULT(0, 0);
}

void CPHMath2DCtrl::fireLinkTo(const char *tags)
{
	// 󕶎̂ƂCxg𔭐
	::SysFreeString(m_bstrLinkToBuf);
	m_strLinkToBuf = tags;
	m_bstrLinkToBuf = m_strLinkToBuf.AllocSysString();
	FireLinkTo(&m_bstrLinkToBuf);
}

void CPHMath2DCtrl::OnDestroy() 
{
	COleControl::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	KillTimer(HILIGHT_TIMER_ID);
}

BSTR CPHMath2DCtrl::GetFilename() 
{
	CString strResult;
	// TODO: è ׂǉĂ
	strResult = m_filename;
	return strResult.AllocSysString();
}

void CPHMath2DCtrl::SetFilename(LPCTSTR lpszNewValue) 
{
	// TODO: è ׂǉĂ
	m_filename = lpszNewValue;
	FREE(m_drawer);
	::SendMessage(m_hWnd, WM_FILENAME_UPDATE, 0, 0);
	SetModifiedFlag();
}

long CPHMath2DCtrl::GetHilightColor() 
{
	// TODO: è ׂǉĂ
	return 0;
}

void CPHMath2DCtrl::SetHilightColor(long nNewValue) 
{
	// TODO: è ׂǉĂ
	SetModifiedFlag();
}

void CPHMath2DCtrl::hilight(short tag) 
{
	// TODO: ި߯  ނǉĂB
	if (m_drawer) { m_drawer->hilight(tag); }
}

void CPHMath2DCtrl::write(const char *msg, int line)
{
	char buf[1024];
	sprintf(buf, "%d : %s", line, msg);
	MessageBox(buf);
}

void CPHMath2DCtrl::initDrawer(HDC hDC)
{
	// Ƃ肠̑傫ōĂB
	const int W = 10;
	const int H = 10;
	m_drawer = new Math2DWinDrawer(hDC, W, H, *m_creator);
	m_drawer->setContentUpdateListener(this);
	m_drawer->setErrorTextWriter(this);
}

void CPHMath2DCtrl::hilightOff() 
{
	hilight(0);
}

void CPHMath2DCtrl::hilightAllChar(LPCTSTR tags) 
{
	if (m_drawer) { m_drawer->hilight(tags); }
}


short CPHMath2DCtrl::GetFontsize() 
{
	return m_creator->fontSize();
}

void CPHMath2DCtrl::SetFontsize(short nNewValue) 
{
	m_creator->fontSize(nNewValue);
	SetModifiedFlag();
}

long CPHMath2DCtrl::GetStartNumber() 
{
	return m_creator->startNumber();
}

void CPHMath2DCtrl::SetStartNumber(long nNewValue) 
{
	m_creator->startNumber(nNewValue);
	SetModifiedFlag();
}

BOOL CPHMath2DCtrl::GetEnumeration() 
{
	return m_enum;
}

void CPHMath2DCtrl::SetEnumeration(BOOL bNewValue) 
{
	m_enum = bNewValue;
	SetModifiedFlag();
}

BSTR CPHMath2DCtrl::getVersion() 
{
	CString strResult;
	// TODO: ި߯  ނǉĂB
	strResult = ::getVersion();

	return strResult.AllocSysString();
}

void CPHMath2DCtrl::redraw() 
{
	// TODO: ި߯  ނǉĂB
	::SendMessage(m_hWnd, WM_REDRAW, 0, 0);
}

long CPHMath2DCtrl::loadConf(LPCTSTR fname) 
{
	// TODO: ި߯  ނǉĂB
	loadConfig(fname);
	redraw();
	return 1;
}
