#if !defined(AFX_PHMATH2DCTL_H__B20405E4_98D5_4562_B999_9913B80BC191__INCLUDED_)
#define AFX_PHMATH2DCTL_H__B20405E4_98D5_4562_B999_9913B80BC191__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// PHMath2DCtl.h : CPHMath2DCtrl ActiveX Rg[ NX̐錾

#include "Math2DWinDrawer.h"
#include "ErrorTextWriter.h"
#include "Math2DContextCreator.h"


/////////////////////////////////////////////////////////////////////////////
// CPHMath2DCtrl : ̃NX̓̒`ɊւĂ PHMath2DCtl.cpp QƂĂ

class CPHMath2DCtrl : public COleControl, public Math2DWinDrawer::ContentUpdateListener, public ErrorTextWriter
{
	DECLARE_DYNCREATE(CPHMath2DCtrl)

// RXgN^
public:
	CPHMath2DCtrl();

// I[o[Ch
	// ClassWizard ͉z֐̃I[oCh𐶐܂
	//{{AFX_VIRTUAL(CPHMath2DCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Cve[V
protected:
	~CPHMath2DCtrl();

	enum {
		HILIGHT_TIMER_ID = 10,		// ^C} ID
		HILIGHT_TIMER_ELAPSE = 300,	// ^C}̊Ԋu
	};

	Math2DContextCreator *m_creator;

	BOOL		m_auto;
	CString		m_filename;
	long		m_hilightColor;
	long		m_fontsize;
	long		m_startNumber;
	BOOL		m_enum;

	// LinkToCxgpobt@
	CString		m_strLinkToBuf;
	BSTR		m_bstrLinkToBuf;

	Math2DWinDrawer	*m_drawer;
	int		m_xoffset;	// `ItZbg
	int		m_yoffset;

	SIZE		m_eqSize;	// Ŝ̑傫
	SIZE		m_center;

	ViewBuffer	*m_bgBuffer;	// wiĕ`pobt@

	CPoint		m_cursor;	// ݂̃J[\ʒu
	bool		m_in;

protected:

	// 
	void	init(HDC);
	void	initDrawer(HDC hDC);
	bool	loadConfig(const char *fname);
	bool	loadDefaultConfig();

	// Rg[
	void	inEquationRect(bool b) { m_in = (b)? true: false; }
	bool	inEquationRect() { return m_in; }

	// `
	void	draw();
	void	draw(const char *filename);

	// LinkTo Cxg
	void	fireLinkTo(const char *tag);

	// Math2DWinDrawer::ContentUpdateListener Cve[V
	void	updated();
	void	resize(Length &, Length &);

	// Math2DWinDrawer::ErrorTextWriter Cve[V
	void	write(const char *msg, int);

	DECLARE_OLECREATE_EX(CPHMath2DCtrl)   // NX t@Ng  guid
	DECLARE_OLETYPELIB(CPHMath2DCtrl)     // GetTypeInfo
	DECLARE_PROPPAGEIDS(CPHMath2DCtrl)    // vpeB y[W ID
	DECLARE_OLECTLTYPE(CPHMath2DCtrl)     // ^CvƂ̑̃Xe[^X

// bZ[W }bv
	//{{AFX_MSG(CPHMath2DCtrl)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg LRESULT OnFilenameUpdate(WPARAM, LPARAM);
	afx_msg LRESULT OnRedraw(WPARAM, LPARAM);

// fBXpb` }bv
	//{{AFX_DISPATCH(CPHMath2DCtrl)
	afx_msg BSTR GetFilename();
	afx_msg void SetFilename(LPCTSTR lpszNewValue);
	afx_msg long GetHilightColor();
	afx_msg void SetHilightColor(long nNewValue);
	afx_msg short GetFontsize();
	afx_msg void SetFontsize(short nNewValue);
	afx_msg long GetStartNumber();
	afx_msg void SetStartNumber(long nNewValue);
	afx_msg BOOL GetEnumeration();
	afx_msg void SetEnumeration(BOOL bNewValue);
	afx_msg void hilight(short tag);
	afx_msg void hilightOff();
	afx_msg void hilightAllChar(LPCTSTR tags);
	afx_msg BSTR getVersion();
	afx_msg void redraw();
	afx_msg long loadConf(LPCTSTR fname);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Cxg }bv
	//{{AFX_EVENT(CPHMath2DCtrl)
	void FireLinkTo(BSTR FAR* tags)
		{FireEvent(eventidLinkTo,EVENT_PARAM(VTS_PBSTR), tags);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// fBXpb`  Cxg ID
public:
	enum {
	//{{AFX_DISP_ID(CPHMath2DCtrl)
	dispidFilename = 1L,
	dispidHilightColor = 2L,
	dispidFontsize = 3L,
	dispidStartNumber = 4L,
	dispidEnumeration = 5L,
	dispidHilight = 6L,
	dispidHilightOff = 7L,
	dispidHilightAllChar = 8L,
	dispidGetVersion = 9L,
	dispidRedraw = 10L,
	dispidLoadConf = 12L,
	eventidLinkTo = 1L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PHMATH2DCTL_H__B20405E4_98D5_4562_B999_9913B80BC191__INCLUDED)
