// parsertest.cpp : AvP[VpNX̋@\`s܂B
//

#include "stdafx.h"
#include "parsertest.h"

#include "MainFrm.h"
#include "parsertestDoc.h"
#include "parsertestView.h"

#include "Version.h"
#include "Copyright.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParsertestApp

BEGIN_MESSAGE_MAP(CParsertestApp, CWinApp)
	//{{AFX_MSG_MAP(CParsertestApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// ẄZbgAbv R}h
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParsertestApp NX̍\z

CParsertestApp::CParsertestApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
}

/////////////////////////////////////////////////////////////////////////////
// B CParsertestApp IuWFNg

CParsertestApp theApp;

#include "ResourceBitmapObjectCreator.h"
#include "EquationImageFactory.h"
#include "Math2DWinDrawer.h"

static ResourceBitmapObjectCreator *creators[EquationImageFactory::IMAGE_TYPE_NUM];
static int creator_num = 0;


/////////////////////////////////////////////////////////////////////////////
// CParsertestApp NX̏


BOOL CParsertestApp::InitInstance()
{
	AfxEnableControlContainer();

	// WIȏ
	// ̋@\gpAst@C̃TCY
	// Έȉ̓̏[`̒sKvȂ
	// 폜ĂB

#ifdef _AFXDLL
	Enable3dControls();		// L DLL ̒ MFC gpꍇɂ͂ĂяoĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNĂꍇɂ͂ĂяoĂB
#endif

	// ݒ肪ۑ鉺̃WXg L[ύX܂B
	// TODO: ̕AЖ܂͏ȂǓK؂Ȃ̂
	// ύXĂB
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // W INI t@C̃IvV[ނ܂ (MRU ܂)

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CParsertestDoc),
		RUNTIME_CLASS(CMainFrame),       // C SDI t[ EBhE
		RUNTIME_CLASS(CParsertestView));
	AddDocTemplate(pDocTemplate);

	// PH init
	Math2DWinDrawer::initDrawer();
	EquationImageFactory::init();
	HINSTANCE hInst = this->m_hInstance;

#define SET_IMAGE(HINST, TYPE, BMPID)  {\
	ResourceBitmapObjectCreator *p = new ResourceBitmapObjectCreator(HINST, BMPID); \
	EquationImageFactory::set(EquationImageFactory::TYPE, p); \
	creators[creator_num++] = p;\
}

#define DEF_IMAGE_RESOURCE(TYPE, BMPID) SET_IMAGE(hInst, TYPE, BMPID)
#include "ImageResource.h"

	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// R}hCŃfBXpb` R}hw肵܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;



	// C EBhEꂽ̂ŁA\ƍXVs܂B
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

				 

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CParsertestApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CParsertestApp bZ[W nh

int CParsertestApp::ExitInstance() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
/*
	for (int i=0; i<creator_num; i++){
		ResourceBitmapObjectCreator *p = creators[i];
		delete p;
	}
	*/
	EquationImageFactory::free_();
	Math2DWinDrawer::freeDrawer();
	return CWinApp::ExitInstance();
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	char buf[1024];
	sprintf(buf, "MatEx-2D Viewer / %s", getVersion());

	GetDlgItem(IDC_STATIC_VERSION)->SetWindowText(buf);

	GetDlgItem(IDC_STATIC_COPYRIGHT)->SetWindowText(getCopyright());
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
