// parsertestDoc.h : CParsertestDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARSERTESTDOC_H__73675D8E_F294_4861_B1C3_DE476A84B324__INCLUDED_)
#define AFX_PARSERTESTDOC_H__73675D8E_F294_4861_B1C3_DE476A84B324__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Math2DWinDrawer.h"
#include "Math2DContextCreator.h"

class CParsertestDoc : public CDocument
{
protected: // VACY@\݂̂쐬܂B
	CParsertestDoc();
	DECLARE_DYNCREATE(CParsertestDoc)

// Agr[g
public:
	long			m_fontsize;
	long			m_startNumber;
	BOOL			m_enum;

	Math2DWinDrawer		*m_drawer;
	Math2DContextCreator	*m_creator;
	CString			m_infile;

// Iy[V
public:
	void init(HDC hDC, int width, int height)
	{
		m_drawer = new Math2DWinDrawer(hDC, width, height, *m_creator);
	}

	void	draw() 
	{
		if (m_infile.GetLength() > 0) {
			draw(m_infile);
			m_infile ="";
		}

	}

	void	draw(const char *filename)
	{
		m_drawer->clear();
		m_drawer->draw(filename);
	}

	void	resize(HDC hDC, int width, int height)
	{
		m_drawer->resizeBuffer(hDC, width, height );
	}

//I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CParsertestDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CParsertestDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CParsertestDoc)
		//  - ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PARSERTESTDOC_H__73675D8E_F294_4861_B1C3_DE476A84B324__INCLUDED_)
