// parsertestView.cpp : CParsertestView NX̓̒`s܂B
//

#include "stdafx.h"
#include "parsertest.h"

#include "parsertestDoc.h"
#include "parsertestView.h"

#include "ViewBuffer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParsertestView

IMPLEMENT_DYNCREATE(CParsertestView, CView)

BEGIN_MESSAGE_MAP(CParsertestView, CView)
	//{{AFX_MSG_MAP(CParsertestView)
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParsertestView NX̍\z/

CParsertestView::CParsertestView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	m_err[0] = 0;
	m_currMousePos.x = 0;
	m_currMousePos.y = 0;
}

CParsertestView::~CParsertestView()
{
}

BOOL CParsertestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CParsertestView NX̕`

void CParsertestView::OnDraw(CDC* pDC)
{
	CParsertestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B

	HDC hDC = pDC->m_hDC;
	if (!pDoc->m_drawer) {
		RECT rect;
		GetClientRect(&rect);
		pDoc->init(hDC, rect.right, rect.bottom);
		pDoc->m_drawer->setContentUpdateListener(this);
		pDoc->m_drawer->setErrorTextWriter(this);
	}
	pDoc->draw();


	ViewBuffer *buffer = pDoc->m_drawer->getBuffer();
	if (buffer) {
		RECT rect;
		GetClientRect(&rect);
		int sx = (rect.right - buffer->width())/2;
		const int sy = 0;
		::BitBlt(hDC, sx, sy, buffer->width(), buffer->height(), buffer->getDC(), 0, 0, SRCCOPY);
#if 1
		if (m_err[0]) {
			::TextOut(hDC, 10, 500, m_err, strlen(m_err));
		}
#endif
	}

}

/////////////////////////////////////////////////////////////////////////////
// CParsertestView NẌ

BOOL CParsertestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CParsertestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CParsertestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CParsertestView NX̐ff

#ifdef _DEBUG
void CParsertestView::AssertValid() const
{
	CView::AssertValid();
}

void CParsertestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CParsertestDoc* CParsertestView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CParsertestDoc)));
	return (CParsertestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CParsertestView NX̃bZ[W nh

void CParsertestView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	m_currMousePos = point;
	
	CView::OnMouseMove(nFlags, point);
}

void CParsertestView::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	CParsertestDoc *pDoc = GetDocument();
	Math2DWinDrawer *drawer = pDoc->m_drawer;
	if (drawer) {
		drawer->inLinkRect(m_currMousePos.x, m_currMousePos.y);
		//		if (b) { InvalidateRect(NULL); }
	}
	
	CView::OnTimer(nIDEvent);
}

void CParsertestView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	SetTimer(HILIGHT_TIMER_ID, HILIGHT_TIMER_ELAPSE, 0);
	DragAcceptFiles();
	
}

void CParsertestView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	KillTimer(HILIGHT_TIMER_ID);
	
}

#define MAX(a, b) (((a) > (b))? (a): (b))

void CParsertestView::resize(Length &wl, Length &hl)
{
	int	w = 2*wl.wide_side();
	int	h = 2*hl.wide_side();
	GetDocument()->resize(GetDC()->m_hDC, w, h);
	CRect rect;
	GetClientRect(&rect);

	int width = MAX(rect.right, w);
	int height = MAX(rect.bottom, h);
	SetWindowPos(&wndTop, 0, 0, width, height, SWP_NOMOVE);

}


void CParsertestView::OnDropFiles(HDROP hDropInfo) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	int n = DragQueryFile(hDropInfo,  0xffffffff, NULL, 0);
	if (n > 2) { 
		MessageBox("2ȏ̃t@Cxɕ`ł܂BPt@CIłB");
	} else if (n == 1) {
		char fname[1024];
		DragQueryFile(hDropInfo, 0, fname, sizeof(fname));
		CParsertestDoc *pDoc = GetDocument();
		pDoc->draw(fname);
		InvalidateRect(NULL);
	}

	CView::OnDropFiles(hDropInfo);
}
